• 关于

    变量中常见的错误

    的搜索结果

回答

生命周期不同,类变量在整个类的生命周期中都可访问,而方法变量只是在这个方法调用的生命周期中可以使用。常见的错误就是把方法的变量放到类里,但是在方法里面修改了类变量的值,另外一个方法用到的时候如果没做判断就会出错。所以最好是控制变量的生命周期,能放到方法里就不要放到类里。
yu_hc200 2019-12-02 02:25:07 0 浏览量 回答数 0

回答

常见错误描述: Apple Mach-O Linker Error这类错误的错误信息最后一行通常如下: Command /Developer/Platforms/iPhoneOS.platform/Developer/usr/bin/clang failed with exit code 1 发生这种错误的原因通常是因为项目中存在同名类造成链接错误。 有可能是你存在两个类名称都一样,也可能是因为你在不同的。m文件中定义了同样的const变量。 这类错误需要自己看错误信息中给出的大长串路径,从中找出你的那个重名类或者变量名称,以此来定位错误位置。 答案来源于网络
养狐狸的猫 2019-12-02 02:19:24 0 浏览量 回答数 0

回答

详细解答可以参考官方帮助文档使用SDK时如果请求出错,会有相应的异常抛出。服务器端异常通常会包含以下信息: status: 出错请求的HTTP状态码code: OSS的错误码message: OSS的错误信息requestId: 标识该次请求的UUID;当您无法解决问题时,可以凭这个RequestId来请求OSS开发工程师的帮助 OSS中常见的错误信息请参考 OSS错误响应 调试在Node.js中您可以通过设置DEBUG环境变量来开启调试: DEBUG=ali-oss node app.js 在浏览器环境中您可以通过在console中设置localStorage.debug变量来开启调试: localStorage.debug = 'ali-oss'
2019-12-01 23:14:19 0 浏览量 回答数 0

回答

详细解答可以参考官方帮助文档使用SDK时如果请求出错,会有相应的异常抛出。服务器端异常通常会包含以下信息: status: 出错请求的HTTP状态码code: OSS的错误码message: OSS的错误信息requestId: 标识该次请求的UUID;当您无法解决问题时,可以凭这个RequestId来请求OSS开发工程师的帮助 OSS中常见的错误信息请参考 OSS错误响应 调试在Node.js中您可以通过设置DEBUG环境变量来开启调试: DEBUG=ali-oss node app.js 在浏览器环境中您可以通过在console中设置localStorage.debug变量来开启调试: localStorage.debug = 'ali-oss'
2019-12-01 23:14:18 0 浏览量 回答数 0

回答

详细解答可以参考官方帮助文档使用SDK时如果请求出错,会有相应的异常抛出。服务器端异常通常会包含以下信息: status: 出错请求的HTTP状态码code: OSS的错误码message: OSS的错误信息requestId: 标识该次请求的UUID;当您无法解决问题时,可以凭这个RequestId来请求OSS开发工程师的帮助 OSS中常见的错误信息请参考 OSS错误响应 调试在Node.js中您可以通过设置DEBUG环境变量来开启调试: DEBUG=ali-oss node app.js 在浏览器环境中您可以通过在console中设置localStorage.debug变量来开启调试: localStorage.debug = 'ali-oss'
2019-12-01 23:14:19 0 浏览量 回答数 0

回答

详细解答可以参考官方帮助文档使用SDK时如果请求出错,会有相应的异常抛出。服务器端异常通常会包含以下信息: status: 出错请求的HTTP状态码code: OSS的错误码message: OSS的错误信息requestId: 标识该次请求的UUID;当您无法解决问题时,可以凭这个RequestId来请求OSS开发工程师的帮助 OSS中常见的错误信息请参考 OSS错误响应 调试在Node.js中您可以通过设置DEBUG环境变量来开启调试: DEBUG=ali-oss node app.js 在浏览器环境中您可以通过在console中设置localStorage.debug变量来开启调试: localStorage.debug = 'ali-oss'
2019-12-01 23:14:18 0 浏览量 回答数 0

回答

详细解答可以参考官方帮助文档使用SDK时如果请求出错,会有相应的异常抛出。服务器端异常通常会包含以下信息: status: 出错请求的HTTP状态码code: OSS的错误码message: OSS的错误信息requestId: 标识该次请求的UUID;当您无法解决问题时,可以凭这个RequestId来请求OSS开发工程师的帮助 OSS中常见的错误信息请参考 OSS错误响应 调试在Node.js中您可以通过设置DEBUG环境变量来开启调试: DEBUG=ali-oss node app.js 在浏览器环境中您可以通过在console中设置localStorage.debug变量来开启调试: localStorage.debug = 'ali-oss'
2019-12-01 23:14:18 0 浏览量 回答数 0

回答

详细解答可以参考官方帮助文档使用SDK时如果请求出错,会有相应的异常抛出。服务器端异常通常会包含以下信息: status: 出错请求的HTTP状态码code: OSS的错误码message: OSS的错误信息requestId: 标识该次请求的UUID;当您无法解决问题时,可以凭这个RequestId来请求OSS开发工程师的帮助 OSS中常见的错误信息请参考 OSS错误响应 调试在Node.js中您可以通过设置DEBUG环境变量来开启调试: DEBUG=ali-oss node app.js 在浏览器环境中您可以通过在console中设置localStorage.debug变量来开启调试: localStorage.debug = 'ali-oss'
2019-12-01 23:14:19 0 浏览量 回答数 0

回答

详细解答可以参考官方帮助文档使用SDK时如果请求出错,会有相应的异常抛出。服务器端异常通常会包含以下信息: status: 出错请求的HTTP状态码code: OSS的错误码message: OSS的错误信息requestId: 标识该次请求的UUID;当您无法解决问题时,可以凭这个RequestId来请求OSS开发工程师的帮助 OSS中常见的错误信息请参考 OSS错误响应 调试在Node.js中您可以通过设置DEBUG环境变量来开启调试: DEBUG=ali-oss node app.js 在浏览器环境中您可以通过在console中设置localStorage.debug变量来开启调试: localStorage.debug = 'ali-oss'
2019-12-01 23:14:18 0 浏览量 回答数 0

回答

详细解答可以参考官方帮助文档使用SDK时如果请求出错,会有相应的异常抛出。服务器端异常通常会包含以下信息: status: 出错请求的HTTP状态码code: OSS的错误码message: OSS的错误信息requestId: 标识该次请求的UUID;当您无法解决问题时,可以凭这个RequestId来请求OSS开发工程师的帮助 OSS中常见的错误信息请参考 OSS错误响应 调试在Node.js中您可以通过设置DEBUG环境变量来开启调试: DEBUG=ali-oss node app.js 在浏览器环境中您可以通过在console中设置localStorage.debug变量来开启调试: localStorage.debug = 'ali-oss'
2019-12-01 23:14:18 0 浏览量 回答数 0

问题

JavaScript-SDK 之如何实现异常?

使用SDK时如果请求出错,会有相应的异常抛出。服务器端异常通常会包含以下信息: status: 出错请求的HTTP状态码code: OSS的错误码message: OSS的错误信息requestId: 标识该次请...
青衫无名 2019-12-01 21:44:39 1014 浏览量 回答数 0

回答

在很大程度上,标准C++是标准C的超集.实际上,所有C程序也是C++程序,然而,两者之间有少量区别.下面简要介绍一下最重要的区别.1、 在C++中,民,局部变量可以在一个程序块内在任何地方声明,在C中,局部变量必须在程序块的开始部分,即在所有"操作"语句之前声明,请注意,C99标准中取消了这种限制.2、在C中,按如下方式声明的函数没有对函数参数进行任何说明;int func();也就是说,如果没有在函数后面的括孤内指定任何参数,这在C中就意味着对函数参数未做任何声明,该函数可能有参数,也可能没有参数,然而,在C++中,这样的函数声明意味着该函数没有参数,也就是说,在C++中,下面这两个函数声明具有同样的作用:int func();int func(void);在C++中,参数列表中的void是任选的.许多C++程序员使用它们是为了表明函数没有任何参数的,以便于他人理解程序.但是,从技术上说,void不是必须的. 3、 在C++中,所有函数均必须被设计成原型,但这在C中只是一种选择.编程经验表明,在程序中也应该给函数采用原型设计方法.在C与C++之间还存在一个重要而又细微的差别,即字符常数在C中被自动作为整形来处理,但在C++中则不然.4、在C中,多次声明一个全局变量虽然不可取,但不算错.在C++中,多次声明同一个全局变量会引发错误.5、在C中,一个标识符可以至少31个有效的组成字符.在C++中,一个标识符的所有组成字符均是有效的.可是,从实用角度看,过长的标识符没有太大的用处,不仅不便于记忆,而且还会增加出现打字错误的可能性.6、在C中,在程序内部调用main()函数的情形不常见,但这种做法是容许的,在C++中,这种做法是不容许的. 7、在C中,无法获得register型的地址,在C++中则可以获得这种地址.8、在C中,如果类型声明语句中没有指定类型名,该类型被假定成int,这种隐式转型在C99与C++中是不允许的.。
a123456678 2019-12-02 01:59:29 0 浏览量 回答数 0

回答

在很大程度上,标准C++是标准C的超集.实际上,所有C程序也是C++程序,然而,两者之间有少量区别.下面简要介绍一下最重要的区别.1、 在C++中,民,局部变量可以在一个程序块内在任何地方声明,在C中,局部变量必须在程序块的开始部分,即在所有"操作"语句之前声明,请注意,C99标准中取消了这种限制.2、在C中,按如下方式声明的函数没有对函数参数进行任何说明;int func();也就是说,如果没有在函数后面的括孤内指定任何参数,这在C中就意味着对函数参数未做任何声明,该函数可能有参数,也可能没有参数,然而,在C++中,这样的函数声明意味着该函数没有参数,也就是说,在C++中,下面这两个函数声明具有同样的作用:int func();int func(void);在C++中,参数列表中的void是任选的.许多C++程序员使用它们是为了表明函数没有任何参数的,以便于他人理解程序.但是,从技术上说,void不是必须的. 3、 在C++中,所有函数均必须被设计成原型,但这在C中只是一种选择.编程经验表明,在程序中也应该给函数采用原型设计方法.在C与C++之间还存在一个重要而又细微的差别,即字符常数在C中被自动作为整形来处理,但在C++中则不然.4、在C中,多次声明一个全局变量虽然不可取,但不算错.在C++中,多次声明同一个全局变量会引发错误.5、在C中,一个标识符可以至少31个有效的组成字符.在C++中,一个标识符的所有组成字符均是有效的.可是,从实用角度看,过长的标识符没有太大的用处,不仅不便于记忆,而且还会增加出现打字错误的可能性.6、在C中,在程序内部调用main()函数的情形不常见,但这种做法是容许的,在C++中,这种做法是不容许的. 7、在C中,无法获得register型的地址,在C++中则可以获得这种地址.8、在C中,如果类型声明语句中没有指定类型名,该类型被假定成int,这种隐式转型在C99与C++中是不允许的.。
a123456678 2019-12-02 02:16:26 0 浏览量 回答数 0

问题

短信接口调用错误码

调用API接口会产生接口调用错误码,常见接口调用错误码显示及修改建议,请参考以下列表: 调用接口成功后,运营商异步返回的短信发送状态错误码。请见【短信发送状态回执错误码】 ...
nicenelly 2019-12-01 20:59:28 3100 浏览量 回答数 1

回答

编程最简单的算法之一,莫过于变量交换。交换变量的常见算法需要一个中间变量进行变量的临时保存。用传统方法编写变量交换代码如下: var a int = 100 var b int = 200 var t int t = a a = b b = t fmt.Println(a, b) 在计算机刚发明时,内存非常“精贵”。这种变量交换往往是非常奢侈的。于是计算机“大牛”发明了一些算法来避免使用中间变量: var a int = 100 var b int = 200 a = a ^ b b = b ^ a a = a ^ b fmt.Println(a, b) 这样的算法很多,但是都有一定的数值范围和类型要求。 到了Go语言时,内存不再是紧缺资源,而且写法可以更简单。使用 Go 的“多重赋值”特性,可以轻松完成变量交换的任务: var a int = 100 var b int = 200 b, a = a, b fmt.Println(a, b) 多重赋值时,变量的左值和右值按从左到右的顺序赋值。 多重赋值在Go语言的错误处理和函数返回值中会大量地使用。例如使用Go语言进行排序时就需要使用交换,代码如下: type IntSlice []int func (p IntSlice) Len() int { return len(p) } func (p IntSlice) Less(i, j int) bool { return p[i] < p[j] } func (p IntSlice) Swap(i, j int) { p[i], p[j] = p[j], p[i] } 代码说明如下: 第 1 行,将 IntSlice 声明为 []int 类型。 第 3 行,为 IntSlice 类型编写一个 Len 方法,提供切片的长度。 第 4 行,根据提供的 i、j 元素索引,获取元素后进行比较,返回比较结果。 第 5 行,根据提供的 i、j 元素索引,交换两个元素的值。
游客2q7uranxketok 2021-02-20 01:04:59 0 浏览量 回答数 0

回答

你所指的就是常见的编程错误之一,返回指向栈内存的指针。void fun( int *p ){p = (int *)malloc(sizeof(int));}int main(void){int *ps;fun(ps);printf("heap setn");//可以执行到此*p = 5;//Segmentation fault 发生段错误free(ps);return 0;} fun 函数的参数在栈中,当fun函数结束的时候,fun所持有的栈内存就会消失。p也会消失。在上例中,你实际上传人的是一个指针值,就和其他类型一样,指针也有值,只不过指针的值是一个地址而已,所以你fun(ps)的时候,只是把ps的值(一个地址)copy到p,实际上,ps和p就不在同一个地方,当fun返回后,p消失了,你也就不知道它所申请的内存在哪里了,所以程序可以执行到printf,再往下执行,*p发生段段错误,因为你想要给未知的内存区域赋值。Int *p,这是声明p是指针变量,p 这样是要引用p所指向的内存,例如上例中p = 4;&p 就是取得指针本身的地址,不是指针指向的地址。
a123456678 2019-12-02 02:16:04 0 浏览量 回答数 0

回答

首先你需要知道,进程使用的都是虚拟地址空间,每个进程都有独立的,完整的4GB(32bit下)地址空间,未必每一块内存都会映射到物理内存,这个映射工作是操作系统完成的。如果你访问了地址空间里未映射的内存,或者写了只读的区域,操作系统就会报错(Segment Fault错误,呵呵~)并终止你的程序。当一个进程开始运行时,会向操作系统申请一块“堆”内存,由程序自己对这块堆内存进行管理,malloc就是从这块内存中分配内存,在C语言中,这个申请和管理堆内存的工作是由运行库自动完成的。当free一块内存后,free(即运行库)会将这块内存标记为未使用,下次有可能会将这块内存分配出去。但这块内存对进程来说仍然是可以读写的,因为运行库已经向操作系统申请,自己来管理这块内存了。局部变量是分配在栈上的,进程开始运行时,操作系统会分配给进程一块固定大小(通常是1MB)的栈,所谓分配和释放局部变量,都只是在移动栈顶指针而已,只要没超过栈的这1MB内存区域,都还是可以读写的。以上都是常见操作系统的典型行为,也许在某些操作系统和平台上并非这么工作,总之,使用已释放的内存是非常危险的行为。有兴趣可以读这两本书《深入理解计算机系统》《链接装载与库》
a123456678 2019-12-02 02:35:32 0 浏览量 回答数 0

回答

Kotlin的简介 Kotlin是由JetBrains公司(IDEA开发者)所开发的编程语言,其名称来自于开发团队附近的科特林岛。 多平台开发 JVM :Android; Server-Side Javascript:前端 Native(beta) :开发原生应用 windows、macos、linux Swift与Kotlin非常像 http://nilhcem.com/swift-is-like-kotlin/ kotlin发展历程 image.png java发展历程 image.png JVM语言的原理 image.png JVM规范与java规范是相互独立的 只要生成的编译文件匹配JVM字节码规范,任何语言都可以由JVM编译运行. Kotlin也是一种JVM语言,完全兼容java,可以与java相互调用;Kotlin语言的设计受到Java、C#、JavaScript、Scala、Groovy等语言的启发 kotlin的特性 下面不会罗列kotlin中具体的语法,会介绍我认为比较重要的特性,以及特性背后的东西。 类型推断 空类型设计 函数式编程 类型推断 image.png 类型推断是指编程语言中在编译期自动推导出值的数据类型。推断类型的能力让很多编程任务变得容易,让程序员可以忽略类型标注的同时仍然允许类型检查。 在开发环境中,我们往往写出表达式,然后可以用快捷键来生成变量声明,往往都是很准的,这说明了编译器其实是可以很准确的推断出来类型的。编程语言所具备的类型推断能力可以把类型声明的任务由开发者转到了编译器. java中声明变量的方式是类型写在最前面,后面跟着变量名,这就迫使开发者在声明变量时就要先思考变量的类型要定义成什么,而在一些情况下比如使用集合、泛型类型的变量,定义类型就会变得比较繁琐。 Kotlin中声明变量,类型可以省略,或者放到变量名后面,这可以降低类型的权重,从必选变为可选,降低开发者思维负担。java10中也引入了类型推断。 Javascript中声明变量也是用关键字var,但是还是有本质区别的,Kotlin中的类型推断并不是变成动态类型、弱类型,类型仍然是在编译期就已经决定了的,Kotlin仍然是静态类型、强类型的编程语言。javascript由于是弱类型语言,同一个变量可以不经过强制类型转换就被赋不同数据类型的值, 编程语言的一个趋势就是抽象程度越来越高,编译器做更多的事情。 空类型设计 空类型的由来 image.png 托尼·霍尔(Tony Hoare),图灵奖得主 托尼·霍尔是ALGOL语言的设计者,该语言在编程语言发展历史上非常重要,对其他编程语言产生重大影响,大多数近代编程语言(包括C语言)皆使用类似ALGOL的语法。他在一次大会上讨论了null应用的设计: “我把 null 引用称为自己的十亿美元错误。它的发明是在1965 年,那时我用一个面向对象语言( ALGOL W )设计了第一个全面的引用类型系统。我加入了null引用设计,仅仅是因为实现起来非常容易。它导致了数不清的错误、漏洞和系统崩溃,可能在之后 40 年中造成了十亿美元的损失。” null引用存在的问题 以java为例,看null引用的设计到底存在哪些问题 空指针问题NPE 编译时不能对空指针做出检查,运行时访问null对象就会出现错误,这个就是工程中常见的空指针异常。 null本身没有语义,会存在歧义 值未被初始化 值不存在 也许表示一种状态 逻辑上有漏洞 Java中,null可以赋值给任何引用,比如赋值给String类型变量,String a = null,但是null并不是String类型: a instanceof String 返回的是false,这个其实是有些矛盾的。所以当持有一个String类型的变量,就存在两种情况,null或者真正的String. 解决NPE的方式 防御式代码 在访问对象前判空,但会有冗余代码;会规避问题,而隐藏真正的问题 抛出异常给调用方处理 方法中传参传入的空值、无效值,抛出受检查异常给上层调用方 增加注解 Android中可以增加@NonNull注解,编译时做额外检查 空状态对象设计模式 空状态对象是一个实现接口但是不做任何业务逻辑的对象,可以取代判空检查;这样的空状态对象也可以在数据不可用的时候提供默认的行为 java8 Optional类 java8中引入了Optional类,来解决广泛存在的null引用问题.官方javadoc文档介绍 A container object which may or may not contain a non-null value. If a value is present, isPresent() will return true and get() will return the value. Additional methods that depend on the presence or absence of a contained value are provided, such as orElse() (return a default value if value not present) and ifPresent() (execute a block of code if the value is present). 来看一下是如何实现的。 举一个访问对象读取熟悉的例子 java 8 之前 : image.png java 8: image.png 总结: 1.用Optional还是会比较繁琐,这个也说明了设计一个替代null的方案还是比较难的。 optional的耗时大约是普通判空的数十倍,主要是涉及泛型、使用时多创键了一个对象的创建;数据比较大时,会造成性能损失。 java8 引入Optional的意义在于提示调用者,用特殊类型包装的变量可能为空,在使用取出时需要判断 Kotlin的空类型设计 Kotlin中引入了可空类型和不可空类型的区分,可以区分一个引用可以容纳null,还是不能容纳null。 String vs String? String 类型表示变量不能为空,String?则表示变量可以为空 String?含义是String or null.这两种是不同的类型. 比如: var a:String = “abc” //ok var a:String = null //不允许 var b :String? = null //ok a=b // 不允许 String?类型的值不能给String类型的值赋值 这样就将类型分成了可空类型和不可能类型,每一个类型都有这样的处理;Kotlin中访问非空类型变量永远不会出现空指针异常。 同样上面的例子,采用Kotlin去写,就会简洁很多 image.png 编程范式-函数式编程 编程范式是什么? 编程范式是程序员看待程序和写程序的观点 主要的类型 非结构化编程 结构化编程 面向对象编程 命令式编程 函数式编程 这些类型并不是彼此互斥的,而是按照不同的维度做的划分,一种编程语言可能都支持多个编程范式 非结构化编程 第一代的高级语言往往是非结构化编程 比如 BASIC语言 每一行的代码前面都有一个数字作为行号,通常使用GOTO的跳跃指令来实现判断和循环. 看一下下面这段代码是做什么的: image.png 实际上做的是:程序在屏幕上显示数字 1 到 10 及其对应的平方 采用这种方式写程序,大量的使用goto实现逻辑的跳转,代码一长,可读性和维护性就比较差了,形成“面条式代码” 结构化编程 采用顺序、分支、循环结构来表达,禁用或者少用GOTO; 并用子程序来组织代码,采用自顶向下的方式来写程序 代表语言是C语言 实现同样的逻辑: image.png 可见采用结构化编程,代码的逻辑会更清晰。 面向对象编程 思想: 将计算机程序视为一组对象的集合,而每个对象都可以接收其他对象发过来的消息,并处理这些消息,计算机程序的执行就是一系列消息在各个对象之间传递。 特性: 封装性、继承性、多态性。 命令式编程 把计算机程序视为一系列的命令集合 主要思想是关注计算机执行的步骤,即一步一步告诉计算机先做什么再做什么。 “先做这,再做那”,强调“怎么做” 实现: 用变量来储存数据,用语句来执行指令,改变变量状态。 基本所有的常见的编程语言都具有此范式 函数式编程 声明式语法,描述要什么,而不是怎么做 类似于SQL语句 语言: kotlin swift python javascript scala 函数是第一等公民 可以赋值给变量,可作为参数传入另一个函数,也可作为函数的返回值 纯函数 y=f(x) 只要输入相同,返回值不变 没有副作用:不修改函数的外部状态 举个栗子 公司部门要进行outing,去哪里是个问题,要考虑多个因素,比如花费、距离、天数等等,有多个备选地点进行选择。 定义一个数据类: image.png 要进行筛选了,分别用sql,kotlin,java来实现 找出花费低于2000元的outing地点信息 SQL image.png Kotlin image.png java 7 image.png 可见kotin的写法还是比较接近于sql的思想的,声明式的写法,而不管具体如何实现;其中的:place->place.money<2000 就是函数,可以作为参数传递给fliter这个高阶函数;而且这个函数没有副作用,不改变外部状态。 再来一个复杂一点的: 找出花费低于5000元,时间不多于4天,按照距离排序的outing地点名称 SQL image.png Kotlin: image.png java 7 image.png 由此可见用kotlin的函数式写法,会更简洁,逻辑也更清晰,这段代码的目标一目了然,这种清晰在于实现了业务逻辑与控制逻辑的分离,业务逻辑就是由函数实现的,比如place->place.money<500,而控制逻辑是由filter,sorterBy等高阶函数实现的。 而java的传统写法是基于对数据的操作,避免不了遍历的操作,业务逻辑与控制逻辑交织在了一起,这段代码的目的就不是那么容易清晰看到的了。 总结 kotlin是实用的现代编程语言,吸收了众多编程语言的优点,支持类型推断、空类型安全、函数式编程、DSL等特性,非常值得学习和使用。
问问小秘 2020-04-30 16:33:40 0 浏览量 回答数 0

回答

有时您的PDO代码会产生类似Call to a member function execute()或类似的错误。甚至没有任何错误,但查询不能完全一样。这意味着您的查询无法执行。 每次查询失败,MySQL都会显示一条错误消息,说明原因。不幸的是,默认情况下,此类错误不会转移到PHP,并且您所拥有的只是上面提到的无提示或神秘的错误消息。因此,配置PHP和PDO报告MySQL错误非常重要。一旦收到错误消息,解决该问题将变得很容易。 为了获得有关该问题的详细信息,请在连接后立即在代码中添加以下行 $dbh->setAttribute( PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION ); ($dbh您的PDO实例变量的名称在哪里)或-更好-将此参数添加为连接选项。之后,所有数据库错误都将转换为PDO异常,如果不理会这些异常,则它们将像常规的PHP错误一样起作用。 如果发生某些特定错误,则极有可能不会引发异常。如果您的query()/ prepare()或execute()通话返回,false但没有例外,请PDO::errorInfo()像这样检查, trigger_error("PDO errorInfo: ".$dbh->errorInfo()); 得到错误消息后,您必须阅读并理解它。听起来似乎太明显了,但是学习者经常忽略错误消息的含义。但大多数情况下,它可以很直接地说明问题: 说,如果它说一个特定的表不存在,则必须检查拼写,错字,字母大小写。另外,您还必须确保您的PHP脚本连接到正确的数据库 或者,如果显示SQL语法有错误,则必须检查SQL。问题点就在错误消息中引用的查询部分之前。 您还必须信任错误消息。如果它说令牌的数量与绑定变量的数量不匹配,那就是。缺少表或列也是如此。如果有选择,无论是您自己的错误还是错误消息是错误的,请始终坚持前者。再次听起来是屈尊的,但是这个站点上的数百个问题证明了此建议非常有用。 请注意,为了查看PDO错误,您通常必须能够查看PHP错误。为此,您必须根据站点环境配置PHP: 在开发服务器上,很容易在屏幕上显示错误,因此必须打开显示错误: error_reporting(E_ALL); ini_set('display_errors',1); 在实时站点上时,必须记录所有错误,但永远不要显示给客户端。为此,可以这样配置PHP: error_reporting(E_ALL); ini_set('display_errors', 0); ini_set('log_errors', 1); 请注意,error_reporting应始终将其设置为E_ALL。 还要注意,尽管存在常见的妄想,但错误报告无需使用try-catch。PHP将以一种更好的形式报告您的PDO错误。未捕获的异常对于开发非常有用,但是如果您要显示自定义的错误页面,仍然不要为此使用try catch,而只需设置自定义错误处理程序即可。简而言之,您不必将PDO错误视为特殊错误,而是将它们视为代码中的任何其他错误。 PS 有时没有错误,但也没有结果。那就意味着,没有符合您条件的数据。因此,即使您可以保证数据和标准都正确,您也必须承认这一事实。他们不是。您必须再次检查它们。我有一篇文章,《如何调试与PDO的数据库交互》,可以对此提供帮助。只需按照此说明逐步进行操作,即可解决您的问题或对堆栈溢出有一个可解答的问题。来源:stack overflow
保持可爱mmm 2020-05-08 09:54:51 0 浏览量 回答数 0

回答

不要将调试弄的过于复杂化。一些简单的错误只需要观察程序堆栈信息就能知道了, 实际的错误一般是堆栈的最后一行。 你在开发的时候,也可以在你需要调试的地方插入一下 print() 函数来诊断信息(只需要最后发布的时候删除这些打印语句即可)。 调试器的一个常见用法是观测某个已经崩溃的函数中的变量。 知道怎样在函数崩溃后进入调试器是一个很有用的技能。 当你想解剖一个非常复杂的程序,底层的控制逻辑你不是很清楚的时候, 插入 pdb.set_trace() 这样的语句就很有用了。 实际上,程序会一直运行到碰到 set_trace() 语句位置,然后立马进入调试器。 然后你就可以做更多的事了。 如果你使用IDE来做Python开发,通常IDE都会提供自己的调试器来替代pdb。 更多这方面的信息可以参考你使用的IDE手册。
景凌凯 2020-04-17 17:59:06 0 浏览量 回答数 0

问题

ECS Linux Apache 有哪些常见启动错误及解决办法

ECS Linux Apache 启动经常遇到各种错误,有的会导致 Apache 启动失败,本文对常见错误及解决办法进行说明。 Fatal error initialising mod_ssl, exiting错...
boxti 2019-12-01 21:55:24 1219 浏览量 回答数 0

回答

你好,可以参考如下文档解决,望采纳。 云服务器 ECS Linux SSH 无法远程登录问题排查指引 注意:本文相关配置及说明在 CentOS 6.5 64 bit 操作系统中进行测试,其它类型及版本操作系统配置可能有所差异,具体情况请参阅相应操作系统官方文档。 注意: SSH 客户端是云服务器 ECS Linux主要的运维途径。管理终端可以用于临时运维,或者在客户端登录出现异常时,用于问题排查分析。 常见的问题现象: 客户端问题 中间网络问题 PAM 安全框架相关问题 Linux 系统环境配置问题 SSH 服务及参数配置问题 SSH 服务关联目录或文件配置问题 SSH 服务密钥配置问题 排查 SSH 无法登录问题步骤 常见的问题现象 下图为 SSH 登录关联因素示意图: 客户端问题 客户端无法正常登录时,先使用不同的 SSH 客户端基于相同账户信息进行登录测试。如果能正常登录,则判断是客户端配置问题,需要对客户端配置或软件运行情况做排查分析。云服务器 ECS Linux 的登录过程说明,参阅登录实例。 中间网络问题 客户端无法正常通过 SSH 连接云服务器时,通过 telnet <服务器 IP> <SSH 服务端口>,比如:telnet 192.168.0.1 22 进行 telnet 端口测试,判断是否是中间网络异常所致。正常情况下,会返回如下图所示的服务端 SSH 软件版本号: 如果端口测试失败,参阅下列文档对客户端到服务器之间的网络做进一步排查分析: ping 丢包或不通时链路测试说明 能 ping 通但端口不通时端口可用性探测说明 网络异常时抓包操作说明 PAM 安全框架相关问题 Linux 系统的 PAM 安全框架,可以加载相关安全模块,对云服务器的账户策略、登录策略等进行访问控制。如果相关配置存在异常,或触发了相关策略,就可能会导致 SSH 登录失败。常见案例如下: SSH 登录时出现如下错误:pam_listfile(sshd:auth): Refused user root for service sshd SSH 登录时出现如下错误:requirement “uid >= 1000” not met by user “root” SSH 登录时出现如下错误:Maximum amount of failed attempts was reached SSH 登录时出现如下错误:login: Module is unknown Linux 系统环境配置问题 Linux 内的系统环境(比如中毒、账户配置、环境变量配置等)如果出现异常,也可能会导致 SSH登录失败。见案例如下: SSH 登录时出现如下错误:ssh_exchange_identification: read: Connection reset by peer 中毒导致 SSH 服务运行异常,出现如下错误:fatal: mm_request_send: write: Broken pipe SSH 启动时出现如下错误:main process exited, code=exited SSH 连接时出现如下错误:pam_limits(sshd:session):could not sent limit for ‘nofile’ SSH 连接时出现如下错误:pam_unix(sshdsession) session closed for user SSH 连接时出现如下错误:error Could not get shadow infromation for root SSH 服务及参数配置问题 SSH 服务的默认配置文件为 /etc/ssh/sshd_config。配置文件中的相关参数配置异常,或启用了相关特性或策略,也可能会导致 SSH 登录失败。常见案例如下: SSH 登录时出现如下错误:Disconnected:No supported authentication methods available SSH 登录时出现如下错误:User root not allowed because not listed in SSH 登录时出现如下错误:Permission denied, please try again SSH 登录时出现如下错误:Too many authentication failures for root SSH 启动时出现如下错误:error while loading shared libraries SSH 启动时出现如下错误:fatal: Cannot bind any address SSH 启动时出现如下错误:Bad configuration options 云服务器 ECS Linux SSH 启用 UseDNS 导致连接速度变慢 SSH 服务关联目录或文件配置问题 SSH 服务基于安全性考虑,在运行时,会对相关目录或文件的权限配置、属组等进行检查。过高或过低的权限配置,都可能会引发服务运行异常,进而导致客户端登录失败。常见案例如下: SSH 登录时出现如下错误:No supported key exchange algorithms SSH 启动时出现如下错误:must be owned by root and not group or word-writable SSH 服务密钥配置问题 SSH 服务采用非对称加密技术,对所传输的数据进行加密。客户端及服务端会交换和校验相关密钥信息的有效性。常见案例如下: SSH 登录时出现如下错误:Host key verification failed 云服务器 ECS Linux SSH 连接交互过程简介 云服务器 ECS Linux SSH 基于密钥交换的自动登录原理简介及配置说明 排查 SSH 无法登录问题步骤 如果根据前述问题场景进行排查和处理后,还是无法正常登录。则建议按照如下步骤进行逐一排查分析: 使用不同的 SSH 客户端及 管理终端 做对比访问测试,判断是否个别客户端自身配置或软件运行问题所致。 参阅中间网络问题相关说明测试网络连通性。 参阅 管理终端登录云服务器,在客户端重新访问测试时执行命令   tailf /var/log/secure。 执行命令   ssh -vvv <服务器 IP>,比如, ssh -vvv 192.168.0.1  获取 Linux 环境详细的 SSH 登录交互日志: 通过管理终端 登录云服务器,检查 SSH 服务运行状态: 执行下列命令检查服务运行状态,正常情况下会返回运行状态及相应进程 PID: [root@centos ~]# service sshd status openssh-daemon (pid 31350) is running... [root@centos ~]# service sshd restart Stopping sshd: [ OK ] Starting sshd: [ OK ] 执行下列命令检查服务监听状态,正常情况下会返回相应端口监听信息: netstat -ano | grep 0.0.0.0:22 tcp 0 0 0.0.0.0:22 0.0.0.0:* LISTEN off (0.00/0/0) 通过 管理终端登录云服务器,然后 ssh 127.0.0.1。如果能正常登录,则推断是系统防火墙或外部安全组策略等配置异常,导致客户端登录失败。 如问题还未解决,请记录前述各步骤的测试结果,及相关日志信息或截图,提交工单联系阿里云。
老离 2019-12-02 00:01:53 0 浏览量 回答数 0

问题

基于阿里云产品的视频方案实验(三)

利用Nginx在ECS搭建RTMP服务器 (一)RTMP流媒体协议及常见技术选型 RTMP(Real Time Messaging Protocol)是常见的流媒体协议࿰...
袖手哥 2019-12-01 21:13:49 10863 浏览量 回答数 0

回答

ECS Linux Apache 启动经常遇到各种错误,有的会导致 Apache 启动失败,本文对常见错误及解决办法进行说明。 ECS Linux Apache 因 mod_ssl 启动失败 问题现象 查看Apache错误日志如下: 执行配置检查  /alidata/server/httpd/bin/apachectl configtest,报错如下: 问题原因 mod_ssl.so 模块加载异常 解决方案 重新编译异常模块 到 Apache 源码路径(以一键安装包为例) /root/sh/sh-1.4.1/httpd-2.4.10/modules/ssl 1、执行如下命令: /alidata/server/httpd/bin/apxs -a -i -c -L /usr/lib64/openssl/engines/lib -c *.c -lcrypto -lssl -ldl 出现如下信息,代表编译正常: 2、再次执行配置检查  /alidata/server/httpd/bin/apachectl configtest,通过。 3、启动 Apache 成功   ECS Windows Apache 启动报错:错误模块 php5ts.dll,错误地址 0x000e890c 问题现象 启动 httpd 时,出现错误,查看日志,Apache 的 error.log 中记录为: [warn] pid file D:/Program Files/Apache Software Foundation/Apache2.2/logs/httpd.pid overwritten -- Unclean shutdown of previous Apache run? Windows 的事件查看器/应用程序中显示为: Application Error 中事件详细信息:错误应用程序 httpd.exe,版本 2.2.17.0,错误模块 php5ts.dll,版本 t5.3.5.0,错误地址 0x000e890c。 问题原因 涉及 php5ts.dll 错误的处理,一类是因为 PHP 只能使用自身版本的 dll,如果出现因为系统路径变量的原因,导致其他版本的 dll 先行引用,则出现错误。 针对此类错误,或是删除其他版本 dll;或修改系统 PATH 变量,将 PHP 的放在前面;或将 PHP 的 dll 放到系统的 System32 目录下。 不过,若确认路径没有问题,PATH 变量中 PHP 的安装目录还在 System32 前,也没有其他版本的 php5ts.dll,让然存在问题,请参考如下解决方法。 解决方案 查看 errorlog,找到报错无法 load 的模块,如下 [14-Mar-2011 10:22:15] PHP Warning: PHP Startup: Unable to load dynamic library 'D:\Program Files\PHP\ext\php_oci8.dll' - 找不到指定的模块。 in Unknown on line 0 [14-Mar-2011 10:22:15] PHP Warning: PHP Startup: Unable to load dynamic library 'D:\Program Files\PHP\ext\php_oci8_11g.dll' - 找不到指定的模块。 in Unknown on line 0 [14-Mar-2011 10:22:15] PHP Warning: PHP Startup: Unable to load dynamic library 'D:\Program Files\PHP\ext\php_pdo_oci.dll' - 找不到指定的模块。 in Unknown on line 0 [14-Mar-2011 10:22:15] PHP Warning: PHP Startup: Unable to load dynamic library 'D:\Program Files\PHP\ext\php_sybase_ct.dll' - 找不到指定的模块。 in Unknown on line 0 回到 php.ini 中,将上面 4 个模块注释掉: [PHP_OCI8];extension=php_oci8.dll[PHP_OCI8_11G];extension=php_oci8_11g.dll[PHP_PDO_OCI];extension=php_pdo_oci.dll[PHP_SYBASE_CT];extension=php_sybase_ct.dll 重新启动 Apache 成功。   ECS Apache 启动失败,日志错误:No space left on device: Couldn't create accept lock 问题现象 Apache 启动未报任何错误,但是启动后 ps -ef | grep httpd 看不到进程。errror_log 显示:No space left on device: Couldn't create accept lock 但是查看空间是正常的,没有空间不足的情况。 问题原因 用户进程通信信号量达到限制导致 解决方案 ipcs -s | grep nobody    #nobody 是创建 Apache 进程的用户名,一般情况下 daemon,根据自己的实际情况写。 使用   ipcs -s -l  可以查看当前系统的设置。 使用  ipcs -su  可以查看当前的使用量 使用  ipcs -s | grep nobody | awk '{print "ipcrm -s" $2}'|sh     可以 kill 掉信号。 然后重新启动 Apache 进程即可。 /etc/init.d/httpd -k start   ECS Apache 启动报错:Starting httpd: httpd: bad user name apache 问题现象 启动 Apache 的时候(例如使用命令“: /etc/init.d/httpd start”)出现错误 :Starting httpd: httpd: bad user name apache(如下图) 问题原因 造成该问题的原因是系统中不存在用户 apache,因此导致启动失败。 验证是否存在 apache 用户,可执行命令: id apache 如提示   “id: apache: No such user”,则说明 apache 用户不存在 解决方案 用以下命令: useradd apache 新创建一个 Apache 用户,然后再启动 httpd。   ECS Apache 启动告警:Could not reliably... qualified domain name 问题现象 Apache 启动报错如下: 问题原因 这是 Apache 的提示信息,因为在配置文件 httpd.conf 中没有绑定域名,这个提示信息就是告诉用户,需要给 Apache 绑定域名。 解决方案 修改 Apache 的配置文件 1.找到 Apache 配置文件的路径,例如阿里云一键安装脚本的路径是:/alidata/server/httpd/conf/ 目录 2.编辑 Apache的 配置文件:httpd.conf 找到 ServerName 一行,将默认的 #ServerName www.example.com:80 取消#号修改为 ServerName 127.0.0.1 注意: 也可以自定义域名 3.启动 Apache 服务 注意: 阿里云一键安装脚本启动方式  /alidata/server/httpd/bin/apachectl restart
KB小秘书 2019-12-02 01:27:51 0 浏览量 回答数 0

回答

一、内存溢出类型 1、java.lang.OutOfMemoryError: PermGen space JVM管理两种类型的内存,堆和非堆。堆是给开发人员用的上面说的就是,是在JVM启动时创建;非堆是留给JVM自己用的,用来存放类的信息的。它和堆不同,运行期内GC不会释放空间。如果web app用了大量的第三方jar或者应用有太多的class文件而恰好MaxPermSize设置较小,超出了也会导致这块内存的占用过多造成溢出,或者tomcat热部署时侯不会清理前面加载的环境,只会将context更改为新部署的,非堆存的内容就会越来越多。 PermGen space的全称是Permanent Generation space,是指内存的永久保存区域,这块内存主要是被JVM存放Class和Meta信息的,Class在被Loader时就会被放到PermGen space中,它和存放类实例(Instance)的Heap区域不同,GC(Garbage Collection)不会在主程序运行期对PermGen space进行清理,所以如果你的应用中有很CLASS的话,就很可能出现PermGen space错误,这种错误常见在web服务器对JSP进行pre compile的时候。如果你的WEB APP下都用了大量的第三方jar, 其大小超过了jvm默认的大小(4M)那么就会产生此错误信息了。 一个最佳的配置例子:(经过本人验证,自从用此配置之后,再未出现过tomcat死掉的情况) set JAVA_OPTS=-Xms800m -Xmx800m -XX:PermSize=128M -XX:MaxNewSize=256m -XX:MaxPermSize=256m 2、java.lang.OutOfMemoryError: Java heap space 第一种情况是个补充,主要存在问题就是出现在这个情况中。其默认空间(即-Xms)是物理内存的1/64,最大空间(-Xmx)是物理内存的1/4。如果内存剩余不到40%,JVM就会增大堆到Xmx设置的值,内存剩余超过70%,JVM就会减小堆到Xms设置的值。所以服务器的Xmx和Xms设置一般应该设置相同避免每次GC后都要调整虚拟机堆的大小。假设物理内存无限大,那么JVM内存的最大值跟操作系统有关,一般32位机是1.5g到3g之间,而64位的就不会有限制了。 注意:如果Xms超过了Xmx值,或者堆最大值和非堆最大值的总和超过了物理内存或者操作系统的最大限制都会引起服务器启动不起来。 垃圾回收GC的角色 JVM调用GC的频度还是很高的,主要两种情况下进行垃圾回收: 当应用程序线程空闲;另一个是java内存堆不足时,会不断调用GC,若连续回收都解决不了内存堆不足的问题时,就会报out of memory错误。因为这个异常根据系统运行环境决定,所以无法预期它何时出现。 根据GC的机制,程序的运行会引起系统运行环境的变化,增加GC的触发机会。 为了避免这些问题,程序的设计和编写就应避免垃圾对象的内存占用和GC的开销。显示调用System.GC()只能建议JVM需要在内存中对垃圾对象进行回收,但不是必须马上回收, 一个是并不能解决内存资源耗空的局面,另外也会增加GC的消耗。 二、JVM内存区域组成 简单的说java中的堆和栈 java把内存分两种:一种是栈内存,另一种是堆内存 1。在函数中定义的基本类型变量和对象的引用变量都在函数的栈内存中分配; 2。堆内存用来存放由new创建的对象和数组 在函数(代码块)中定义一个变量时,java就在栈中为这个变量分配内存空间,当超过变量的作用域后,java会自动释放掉为该变量所分配的内存空间;在堆中分配的内存由java虚拟机的自动垃圾回收器来管理 堆的优势是可以动态分配内存大小,生存期也不必事先告诉编译器,因为它是在运行时动态分配内存的。缺点就是要在运行时动态分配内存,存取速度较慢; 栈的优势是存取速度比堆要快,缺点是存在栈中的数据大小与生存期必须是确定的无灵活性。 java堆分为三个区:New、Old和Permanent GC有两个线程: 新创建的对象被分配到New区,当该区被填满时会被GC辅助线程移到Old区,当Old区也填满了会触发GC主线程遍历堆内存里的所有对象。Old区的大小等于Xmx减去-Xmn java栈存放 栈调整:参数有+UseDefaultStackSize -Xss256K,表示每个线程可申请256k的栈空间 每个线程都有他自己的Stack 三、JVM如何设置虚拟内存 提示:在JVM中如果98%的时间是用于GC且可用的Heap size 不足2%的时候将抛出此异常信息。 提示:Heap Size 最大不要超过可用物理内存的80%,一般的要将-Xms和-Xmx选项设置为相同,而-Xmn为1/4的-Xmx值。 提示:JVM初始分配的内存由-Xms指定,默认是物理内存的1/64;JVM最大分配的内存由-Xmx指定,默认是物理内存的1/4。 默认空余堆内存小于40%时,JVM就会增大堆直到-Xmx的最大限制;空余堆内存大于70%时,JVM会减少堆直到-Xms的最小限制。因此服务器一般设置-Xms、-Xmx相等以避免在每次GC 后调整堆的大小。 提示:假设物理内存无限大的话,JVM内存的最大值跟操作系统有很大的关系。 简单的说就32位处理器虽然可控内存空间有4GB,但是具体的操作系统会给一个限制, 这个限制一般是2GB-3GB(一般来说Windows系统下为1.5G-2G,Linux系统下为2G-3G),而64bit以上的处理器就不会有限制了 提示:注意:如果Xms超过了Xmx值,或者堆最大值和非堆最大值的总和超过了物理内存或者操作系统的最大限制都会引起服务器启动不起来。 提示:设置NewSize、MaxNewSize相等,"new"的大小最好不要大于"old"的一半,原因是old区如果不够大会频繁的触发"主" GC ,大大降低了性能 JVM使用-XX:PermSize设置非堆内存初始值,默认是物理内存的1/64; 由XX:MaxPermSize设置最大非堆内存的大小,默认是物理内存的1/4。 解决方法:手动设置Heap size 修改TOMCAT_HOME/bin/catalina.bat 在“echo "Using CATALINA_BASE: $CATALINA_BASE"”上面加入以下行: JAVA_OPTS="-server -Xms800m -Xmx800m -XX:MaxNewSize=256m" 四、性能检查工具使用 定位内存泄漏: JProfiler工具主要用于检查和跟踪系统(限于Java开发的)的性能。JProfiler可以通过时时的监控系统的内存使用情况,随时监视垃圾回收,线程运行状况等手段,从而很好的监视JVM运行情况及其性能。 1. 应用服务器内存长期不合理占用,内存经常处于高位占用,很难回收到低位; 2. 应用服务器极为不稳定,几乎每两天重新启动一次,有时甚至每天重新启动一次; 3. 应用服务器经常做Full GC(Garbage Collection),而且时间很长,大约需要30-40秒,应用服务器在做Full GC的时候是不响应客户的交易请求的,非常影响系统性能。 因为开发环境和产品环境会有不同,导致该问题发生有时会在产品环境中发生,通常可以使用工具跟踪系统的内存使用情况,在有些个别情况下或许某个时刻确实是使用了大量内存导致out of memory,这时应继续跟踪看接下来是否会有下降, 如果一直居高不下这肯定就因为程序的原因导致内存泄漏。 五、不健壮代码的特征及解决办法 1、尽早释放无用对象的引用。好的办法是使用临时变量的时候,让引用变量在退出活动域后,自动设置为null,暗示垃圾收集器来收集该对象,防止发生内存泄露。 对于仍然有指针指向的实例,jvm就不会回收该资源,因为垃圾回收会将值为null的对象作为垃圾,提高GC回收机制效率; 2、我们的程序里不可避免大量使用字符串处理,避免使用String,应大量使用StringBuffer,每一个String对象都得独立占用内存一块区域; String str = "aaa"; String str2 = "bbb"; String str3 = str + str2;//假如执行此次之后str ,str2以后再不被调用,那它就会被放在内存中等待Java的gc去回收,程序内过多的出现这样的情况就会报上面的那个错误,建议在使用字符串时能使用StringBuffer就不要用String,这样可以省不少开销; 3、尽量少用静态变量,因为静态变量是全局的,GC不会回收的; 4、避免集中创建对象尤其是大对象,JVM会突然需要大量内存,这时必然会触发GC优化系统内存环境;显示的声明数组空间,而且申请数量还极大。 这是一个案例想定供大家警戒 使用jspsmartUpload作文件上传,运行过程中经常出现java.outofMemoryError的错误, 检查之后发现问题:组件里的代码 m_totalBytes = m_request.getContentLength(); m_binArray = new byte[m_totalBytes]; 问题原因是totalBytes这个变量得到的数极大,导致该数组分配了很多内存空间,而且该数组不能及时释放。解决办法只能换一种更合适的办法,至少是不会引发outofMemoryError的方式解决。 5、尽量运用对象池技术以提高系统性能;生命周期长的对象拥有生命周期短的对象时容易引发内存泄漏,例如大集合对象拥有大数据量的业务对象的时候,可以考虑分块进行处理,然后解决一块释放一块的策略。 6、不要在经常调用的方法中创建对象,尤其是忌讳在循环中创建对象。可以适当的使用hashtable,vector 创建一组对象容器,然后从容器中去取那些对象,而不用每次new之后又丢弃 7、一般都是发生在开启大型文件或跟数据库一次拿了太多的数据,造成 Out Of Memory Error 的状况,这时就大概要计算一下数据量的最大值是多少,并且设定所需最小及最大的内存空间值。 “答案来源于网络,供您参考” 希望以上信息可以帮到您!
牧明 2019-12-02 02:16:21 0 浏览量 回答数 0

回答

异常是程序中的一些错误,但并不是所有的错误都是异常,并且错误有时候是可以避免的。 比如说,你的代码少了一个分号,那么运行出来结果是提示是错误 java.lang.Error;如果你用System.out.println(11/0),那么你是因为你用0做了除数,会抛出 java.lang.ArithmeticException 的异常。 异常发生的原因有很多,通常包含以下几大类: 用户输入了非法数据。 要打开的文件不存在。 网络通信时连接中断,或者JVM内存溢出。 这些异常有的是因为用户错误引起,有的是程序错误引起的,还有其它一些是因为物理错误引起的。- 要理解Java异常处理是如何工作的,你需要掌握以下三种类型的异常: 检查性异常:最具代表的检查性异常是用户错误或问题引起的异常,这是程序员无法预见的。例如要打开一个不存在文件时,一个异常就发生了,这些异常在编译时不能被简单地忽略。 运行时异常: 运行时异常是可能被程序员避免的异常。与检查性异常相反,运行时异常可以在编译时被忽略。 错误: 错误不是异常,而是脱离程序员控制的问题。错误在代码中通常被忽略。例如,当栈溢出时,一个错误就发生了,它们在编译也检查不到的。 Exception 类的层次 所有的异常类是从 java.lang.Exception 类继承的子类。 Exception 类是 Throwable 类的子类。除了Exception类外,Throwable还有一个子类Error 。 Java 程序通常不捕获错误。错误一般发生在严重故障时,它们在Java程序处理的范畴之外。 Error 用来指示运行时环境发生的错误。 例如,JVM 内存溢出。一般地,程序不会从错误中恢复。 异常类有两个主要的子类:IOException 类和 RuntimeException 类。 在 Java 内置类中(接下来会说明),有大部分常用检查性和非检查性异常。 Java 内置异常类 Java 语言定义了一些异常类在 java.lang 标准包中。 标准运行时异常类的子类是最常见的异常类。由于 java.lang 包是默认加载到所有的 Java 程序的,所以大部分从运行时异常类继承而来的异常都可以直接使用。 Java 根据各个类库也定义了一些其他的异常,下面的表中列出了 Java 的非检查性异常。 异常 描述 ArithmeticException 当出现异常的运算条件时,抛出此异常。例如,一个整数"除以零"时,抛出此类的一个实例。 ArrayIndexOutOfBoundsException 用非法索引访问数组时抛出的异常。如果索引为负或大于等于数组大小,则该索引为非法索引。 ArrayStoreException 试图将错误类型的对象存储到一个对象数组时抛出的异常。 ClassCastException 当试图将对象强制转换为不是实例的子类时,抛出该异常。 IllegalArgumentException 抛出的异常表明向方法传递了一个不合法或不正确的参数。 IllegalMonitorStateException 抛出的异常表明某一线程已经试图等待对象的监视器,或者试图通知其他正在等待对象的监视器而本身没有指定监视器的线程。 IllegalStateException 在非法或不适当的时间调用方法时产生的信号。换句话说,即 Java 环境或 Java 应用程序没有处于请求操作所要求的适当状态下。 IllegalThreadStateException 线程没有处于请求操作所要求的适当状态时抛出的异常。 IndexOutOfBoundsException 指示某排序索引(例如对数组、字符串或向量的排序)超出范围时抛出。 NegativeArraySizeException 如果应用程序试图创建大小为负的数组,则抛出该异常。 NullPointerException 当应用程序试图在需要对象的地方使用 null 时,抛出该异常 NumberFormatException 当应用程序试图将字符串转换成一种数值类型,但该字符串不能转换为适当格式时,抛出该异常。 SecurityException 由安全管理器抛出的异常,指示存在安全侵犯。 StringIndexOutOfBoundsException 此异常由 String 方法抛出,指示索引或者为负,或者超出字符串的大小。 UnsupportedOperationException 当不支持请求的操作时,抛出该异常。 下面的表中列出了 Java 定义在 java.lang 包中的检查性异常类。 异常 描述 ClassNotFoundException 应用程序试图加载类时,找不到相应的类,抛出该异常。 CloneNotSupportedException 当调用 Object 类中的 clone 方法克隆对象,但该对象的类无法实现 Cloneable 接口时,抛出该异常。 IllegalAccessException 拒绝访问一个类的时候,抛出该异常。 InstantiationException 当试图使用 Class 类中的 newInstance 方法创建一个类的实例,而指定的类对象因为是一个接口或是一个抽象类而无法实例化时,抛出该异常。 InterruptedException 一个线程被另一个线程中断,抛出该异常。 NoSuchFieldException 请求的变量不存在 NoSuchMethodException 请求的方法不存在 异常方法 下面的列表是 Throwable 类的主要方法: 序号 方法及说明 1 public String getMessage() 返回关于发生的异常的详细信息。这个消息在Throwable 类的构造函数中初始化了。 2 public Throwable getCause() 返回一个Throwable 对象代表异常原因。 3 public String toString() 使用getMessage()的结果返回类的串级名字。 4 public void printStackTrace() 打印toString()结果和栈层次到System.err,即错误输出流。 5 public StackTraceElement [] getStackTrace() 返回一个包含堆栈层次的数组。下标为0的元素代表栈顶,最后一个元素代表方法调用堆栈的栈底。 6 public Throwable fillInStackTrace() 用当前的调用栈层次填充Throwable 对象栈层次,添加到栈层次任何先前信息中。 捕获异常 使用 try 和 catch 关键字可以捕获异常。try/catch 代码块放在异常可能发生的地方。 try/catch代码块中的代码称为保护代码,使用 try/catch 的语法如下: try { // 程序代码 }catch(ExceptionName e1) { //Catch 块 } Catch 语句包含要捕获异常类型的声明。当保护代码块中发生一个异常时,try 后面的 catch 块就会被检查。 如果发生的异常包含在 catch 块中,异常会被传递到该 catch 块,这和传递一个参数到方法是一样。 实例 下面的例子中声明有两个元素的一个数组,当代码试图访问数组的第三个元素的时候就会抛出一个异常。 ExcepTest.java 文件代码: // 文件名 : ExcepTest.java import java.io.*; public class ExcepTest{ public static void main(String args[]){ try{ int a[] = new int[2]; System.out.println("Access element three :" + a[3]); }catch(ArrayIndexOutOfBoundsException e){ System.out.println("Exception thrown :" + e); } System.out.println("Out of the block"); } } 以上代码编译运行输出结果如下: Exception thrown :java.lang.ArrayIndexOutOfBoundsException: 3 Out of the block 多重捕获块 一个 try 代码块后面跟随多个 catch 代码块的情况就叫多重捕获。 多重捕获块的语法如下所示: try{ // 程序代码 }catch(异常类型1 异常的变量名1){ // 程序代码 }catch(异常类型2 异常的变量名2){ // 程序代码 }catch(异常类型3 异常的变量名3){ // 程序代码 } 上面的代码段包含了 3 个 catch块。 可以在 try 语句后面添加任意数量的 catch 块。 如果保护代码中发生异常,异常被抛给第一个 catch 块。 如果抛出异常的数据类型与 ExceptionType1 匹配,它在这里就会被捕获。 如果不匹配,它会被传递给第二个 catch 块。 如此,直到异常被捕获或者通过所有的 catch 块。 实例 该实例展示了怎么使用多重 try/catch。 try { file = new FileInputStream(fileName); x = (byte) file.read(); } catch(FileNotFoundException f) { // Not valid! f.printStackTrace(); return -1; } catch(IOException i) { i.printStackTrace(); return -1; } throws/throw 关键字: 如果一个方法没有捕获到一个检查性异常,那么该方法必须使用 throws 关键字来声明。throws 关键字放在方法签名的尾部。 也可以使用 throw 关键字抛出一个异常,无论它是新实例化的还是刚捕获到的。 下面方法的声明抛出一个 RemoteException 异常: import java.io.*; public class className { public void deposit(double amount) throws RemoteException { // Method implementation throw new RemoteException(); } //Remainder of class definition } 一个方法可以声明抛出多个异常,多个异常之间用逗号隔开。 例如,下面的方法声明抛出 RemoteException 和 InsufficientFundsException: import java.io.*; public class className { public void withdraw(double amount) throws RemoteException, InsufficientFundsException { // Method implementation } //Remainder of class definition } finally关键字 finally 关键字用来创建在 try 代码块后面执行的代码块。 无论是否发生异常,finally 代码块中的代码总会被执行。 在 finally 代码块中,可以运行清理类型等收尾善后性质的语句。 finally 代码块出现在 catch 代码块最后,语法如下: try{ // 程序代码 }catch(异常类型1 异常的变量名1){ // 程序代码 }catch(异常类型2 异常的变量名2){ // 程序代码 }finally{ // 程序代码 } 实例 ExcepTest.java 文件代码: public class ExcepTest{ public static void main(String args[]){ int a[] = new int[2]; try{ System.out.println("Access element three :" + a[3]); }catch(ArrayIndexOutOfBoundsException e){ System.out.println("Exception thrown :" + e); } finally{ a[0] = 6; System.out.println("First element value: " +a[0]); System.out.println("The finally statement is executed"); } } } 以上实例编译运行结果如下: Exception thrown :java.lang.ArrayIndexOutOfBoundsException: 3 First element value: 6 The finally statement is executed 注意下面事项: catch 不能独立于 try 存在。 在 try/catch 后面添加 finally 块并非强制性要求的。 try 代码后不能既没 catch 块也没 finally 块。 try, catch, finally 块之间不能添加任何代码。 声明自定义异常 在 Java 中你可以自定义异常。编写自己的异常类时需要记住下面的几点。 所有异常都必须是 Throwable 的子类。 如果希望写一个检查性异常类,则需要继承 Exception 类。 如果你想写一个运行时异常类,那么需要继承 RuntimeException 类。 可以像下面这样定义自己的异常类: class MyException extends Exception{ } 只继承Exception 类来创建的异常类是检查性异常类。 下面的 InsufficientFundsException 类是用户定义的异常类,它继承自 Exception。 一个异常类和其它任何类一样,包含有变量和方法。 实例 以下实例是一个银行账户的模拟,通过银行卡的号码完成识别,可以进行存钱和取钱的操作。 InsufficientFundsException.java 文件代码: // 文件名InsufficientFundsException.java import java.io.*; //自定义异常类,继承Exception类 public class InsufficientFundsException extends Exception { //此处的amount用来储存当出现异常(取出钱多于余额时)所缺乏的钱 private double amount; public InsufficientFundsException(double amount) { this.amount = amount; } public double getAmount() { return amount; } } 为了展示如何使用我们自定义的异常类, 在下面的 CheckingAccount 类中包含一个 withdraw() 方法抛出一个 InsufficientFundsException 异常。 CheckingAccount.java 文件代码: // 文件名称 CheckingAccount.java import java.io.*; //此类模拟银行账户 public class CheckingAccount { //balance为余额,number为卡号 private double balance; private int number; public CheckingAccount(int number) { this.number = number; } //方法:存钱 public void deposit(double amount) { balance += amount; } //方法:取钱 public void withdraw(double amount) throws InsufficientFundsException { if(amount <= balance) { balance -= amount; } else { double needs = amount - balance; throw new InsufficientFundsException(needs); } } //方法:返回余额 public double getBalance() { return balance; } //方法:返回卡号 public int getNumber() { return number; } } 下面的 BankDemo 程序示范了如何调用 CheckingAccount 类的 deposit() 和 withdraw() 方法。 BankDemo.java 文件代码: //文件名称 BankDemo.java public class BankDemo { public static void main(String [] args) { CheckingAccount c = new CheckingAccount(101); System.out.println("Depositing $500..."); c.deposit(500.00); try { System.out.println("\nWithdrawing $100..."); c.withdraw(100.00); System.out.println("\nWithdrawing $600..."); c.withdraw(600.00); }catch(InsufficientFundsException e) { System.out.println("Sorry, but you are short $" + e.getAmount()); e.printStackTrace(); } } } 编译上面三个文件,并运行程序 BankDemo,得到结果如下所示: Depositing $500... Withdrawing $100... Withdrawing $600... Sorry, but you are short $200.0 InsufficientFundsException at CheckingAccount.withdraw(CheckingAccount.java:25) at BankDemo.main(BankDemo.java:13) 通用异常 在Java中定义了两种类型的异常和错误。 JVM(Java虚拟机) 异常:由 JVM 抛出的异常或错误。例如:NullPointerException 类,ArrayIndexOutOfBoundsException 类,ClassCastException 类。 程序级异常:由程序或者API程序抛出的异常。例如 IllegalArgumentException 类,IllegalStateException 类。
游客2q7uranxketok 2021-02-07 20:08:10 0 浏览量 回答数 0

回答

您undefined要先进行检查。如果以相反的方式执行此操作,则在未定义数组的情况下将生成错误。 if (array === undefined || array.length == 0) { // array empty or does not exist } 更新资料 这个答案引起了相当多的关注,因此我想指出,我的原始答案比其他任何事情都更能解决问题中所评估条件的错误顺序。从这个意义上讲,它无法解决几种情况,例如null值,具有length属性的其他类型的对象等。它也不是非常惯用的JavaScript。 万无一失的方法 从注释中获得一些启发,以下是我目前认为是检查数组是否为空或不存在的万无一失的方法。它还考虑到变量可能不引用数组,而是引用其他具有length属性的对象。 if (!Array.isArray(array) || !array.length) { // array does not exist, is not an array, or is empty // ⇒ do not attempt to process array } 分解: Array.isArray()毫不奇怪,它检查其参数是否为数组。这杂草淘汰的价值观一样null,undefined和其他任何不是数组。 请注意,这还将消除类似数组的对象,例如arguments对象和DOM NodeList对象。根据您的情况,这可能不是您要遵循的行为。 该array.length条件检查是否变量的length属性值将为一个truthy值。由于先前的条件已经确定我们确实在处理数组,因此此处不需要array.length != 0或array.length !== 0不需要更严格的比较。 务实的方法 在很多情况下,以上几点似乎有些过头了。也许您正在使用诸如TypeScript之类的高级语言,该语言在编译时会为您执行大多数类型检查,或者您实际上不在乎对象是实际上的数组,还是仅仅是类似数组的对象。 在这种情况下,我倾向于使用以下更惯用的JavaScript: if (!array || !array.length) { // array or array.length are falsy // ⇒ do not attempt to process array } 或更常见的是,它的反函数: if (array && array.length) { // array and array.length are truthy // ⇒ probably OK to process array } 问题来源于stack overflow
保持可爱mmm 2020-01-15 16:33:21 0 浏览量 回答数 0

回答

) 抽象语法树 在计算机科学中,抽象语法树(Abstract Syntax Tree,AST),或简称语法树(Syntax tree),是源代码语法结构的一种抽象表示。它以树状的形式表现编程语言的语法结构,树上的每个节点都表示源代码中的一种结构。 之所以说语法是“抽象”的,是因为这里的语法并不会表示出真实语法中出现的每个细节。比如,嵌套括号被隐含在树的结构中,并没有以节点的形式呈现。而类似于 if else 这样的条件判断语句,可以使用带有两个分支的节点来表示。 以算术表达式 1+3*(4-1)+2 为例,可以解析出的抽象语法树如下图所示: 抽象语法树 图:抽象语法树 抽象语法树可以应用在很多领域,比如浏览器,智能编辑器,编译器。 2) 静态单赋值 在编译器设计中,静态单赋值形式(static single assignment form,通常简写为 SSA form 或是 SSA)是中介码(IR,intermediate representation)的属性,它要求每个变量只分配一次,并且变量需要在使用之前定义。在实践中我们通常会用添加下标的方式实现每个变量只能被赋值一次的特性,这里以下面的代码举一个简单的例子: x := 1 x := 2 y := x 从上面的描述所知,第一行赋值行为是不需要的,因为 x 在第二行被二度赋值并在第三行被使用,在 SSA 下,将会变成下列的形式: x1 := 1 x2 := 2 y1 := x2 从使用 SSA 的中间代码我们就可以非常清晰地看出变量 y1 的值和 x1 是完全没有任何关系的,所以在机器码生成时其实就可以省略第一步,这样就能减少需要执行的指令来优化这一段代码。 根据 Wikipedia(维基百科)对 SSA 的介绍来看,在中间代码中使用 SSA 的特性能够为整个程序实现以下的优化: 常数传播(constant propagation) 值域传播(value range propagation) 稀疏有条件的常数传播(sparse conditional constant propagation) 消除无用的程式码(dead code elimination) 全域数值编号(global value numbering) 消除部分的冗余(partial redundancy elimination) 强度折减(strength reduction) 寄存器分配(register allocation) 因为 SSA 的主要作用就是代码的优化,所以是编译器后端(主要负责目标代码的优化和生成)的一部分。当然,除了 SSA 之外代码编译领域还有非常多的中间代码优化方法,优化编译器生成的代码是一个非常古老并且复杂的领域,这里就不展开介绍了。 3) 指令集架构 最后要介绍的一个预备知识就是指令集架构了,指令集架构(Instruction Set Architecture,简称 ISA),又称指令集或指令集体系,是计算机体系结构中与程序设计有关的部分,包含了基本数据类型,指令集,寄存器,寻址模式,存储体系,中断,异常处理以及外部 I/O。指令集架构包含一系列的 opcode 即操作码(机器语言),以及由特定处理器执行的基本命令。 指令集架构常见种类如下: 复杂指令集运算(Complex Instruction Set Computing,简称 CISC); 精简指令集运算(Reduced Instruction Set Computing,简称 RISC); 显式并行指令集运算(Explicitly Parallel Instruction Computing,简称 EPIC); 超长指令字指令集运算(VLIW)。 不同的处理器(CPU)使用了大不相同的机器语言,所以我们的程序想要在不同的机器上运行,就需要将源代码根据架构编译成不同的机器语言。 编译原理 Go语言编译器的源代码在 cmd/compile 目录中,目录下的文件共同构成了Go语言的编译器,学过编译原理的人可能听说过编译器的前端和后端,编译器的前端一般承担着词法分析、语法分析、类型检查和中间代码生成几部分工作,而编译器后端主要负责目标代码的生成和优化,也就是将中间代码翻译成目标机器能够运行的机器码。 Go的编译器在逻辑上可以被分成四个阶段:词法与语法分析、类型检查和 AST 转换、通用 SSA 生成和最后的机器代码生成,下面我们来分别介绍一下这四个阶段做的工作。 1) 词法与语法分析 所有的编译过程其实都是从解析代码的源文件开始的,词法分析的作用就是解析源代码文件,它将文件中的字符串序列转换成 Token 序列,方便后面的处理和解析,我们一般会把执行词法分析的程序称为词法解析器(lexer)。 而语法分析的输入就是词法分析器输出的 Token 序列,这些序列会按照顺序被语法分析器进行解析,语法的解析过程就是将词法分析生成的 Token 按照语言定义好的文法(Grammar)自下而上或者自上而下的进行规约,每一个 Go 的源代码文件最终会被归纳成一个 SourceFile 结构: SourceFile = PackageClause ";" { ImportDecl ";" } { TopLevelDecl ";" } 标准的 Golang 语法解析器使用的就是 LALR(1) 的文法,语法解析的结果其实就是上面介绍过的抽象语法树(AST),每一个 AST 都对应着一个单独的Go语言文件,这个抽象语法树中包括当前文件属于的包名、定义的常量、结构体和函数等。 如果在语法解析的过程中发生了任何语法错误,都会被语法解析器发现并将消息打印到标准输出上,整个编译过程也会随着错误的出现而被中止。 2) 类型检查 当拿到一组文件的抽象语法树 AST 之后,Go语言的编译器会对语法树中定义和使用的类型进行检查,类型检查分别会按照顺序对不同类型的节点进行验证,按照以下的顺序进行处理: 常量、类型和函数名及类型; 变量的赋值和初始化; 函数和闭包的主体; 哈希键值对的类型; 导入函数体; 外部的声明; 通过对每一棵抽象节点树的遍历,我们在每一个节点上都会对当前子树的类型进行验证保证当前节点上不会出现类型错误的问题,所有的类型错误和不匹配都会在这一个阶段被发现和暴露出来。 类型检查的阶段不止会对树状结构的节点进行验证,同时也会对一些内建的函数进行展开和改写,例如 make 关键字在这个阶段会根据子树的结构被替换成 makeslice 或者 makechan 等函数。 其实类型检查不止对类型进行了验证工作,还对 AST 进行了改写以及处理Go语言内置的关键字,所以,这一过程在整个编译流程中是非常重要的,没有这个步骤很多关键字其实就没有办法工作。 3) 中间代码生成 当我们将源文件转换成了抽象语法树,对整个语法树的语法进行解析并进行类型检查之后,就可以认为当前文件中的代码基本上不存在无法编译或者语法错误的问题了,Go语言的编译器就会将输入的 AST 转换成中间代码。 Go语言编译器的中间代码使用了 SSA(Static Single Assignment Form) 的特性,如果我们在中间代码生成的过程中使用这种特性,就能够比较容易的分析出代码中的无用变量和片段并对代码进行优化。 在类型检查之后,就会通过一个名为 compileFunctions 的函数开始对整个Go语言项目中的全部函数进行编译,这些函数会在一个编译队列中等待几个后端工作协程的消费,这些 Goroutine 会将所有函数对应的 AST 转换成使用 SSA 特性的中间代码。 4) 机器码生成 Go语言源代码的 cmd/compile/internal 目录中包含了非常多机器码生成相关的包,不同类型的 CPU 分别使用了不同的包进行生成 amd64、arm、arm64、mips、mips64、ppc64、s390x、x86 和 wasm,也就是说Go语言能够在几乎全部常见的 CPU 指令集类型上运行。
游客2q7uranxketok 2021-02-20 14:42:25 0 浏览量 回答数 0

回答

如前所述这里: MySQL服务器消失(错误2006)的两个最常见的原因(和修复)是: 服务器超时并关闭了连接。怎么修: 检查mysqld的my.cnf配置文件中的wait_timeout变量是否足够大。在Debian:上sudo nano /etc/mysql/my.cnf,设置wait_timeout = 600秒(当错误2006消失时,您可以调整/减小该值),然后设置sudo /etc/init.d/mysql restart。我没有检查,但是wait_timeout的默认值可能约为28800秒(8小时)。 服务器丢弃了不正确或太大的数据包。如果mysqld收到的数据包太大或不正确,则认为客户端出了点问题,并关闭了连接。您可以通过增加my.cnf文件中的max_allowed_pa​​cket值来增加最大数据包大小限制。在Debian:上sudo nano /etc/mysql/my.cnf,进行设置max_allowed_packet = 64M(当错误2006消失时,您可以调整/减小该值),然后sudo /etc/init.d/mysql restart。 编辑: 请注意,MySQL选项文件尚无其命令作为注释可用(例如php.ini中的命令)。所以,你必须键入任何变化/ TWEAK my.cnf或my.ini并将它们放在mysql/data目录或以任何其它路径的选择,如适当的组下[client],[myslqd]等。例如: [mysqld] wait_timeout = 600 max_allowed_packet = 64M 然后重新启动服务器。要获取它们的值,请输入mysql客户端: select @@wait_timeout; select @@max_allowed_packet;来源:stack overflow
保持可爱mmm 2020-05-10 21:55:35 0 浏览量 回答数 0

问题

【教程免费下载】R语言数据分析

前  言 自20多年前发源于学术界以来,R语言已经成为统计分析的通用语言,活跃于众多产业领域。目前,越来越多的商业项目开始使用R,兼之R用户开发了数以千计易于上手的开发包&#x...
玄学酱 2019-12-01 22:07:40 1232 浏览量 回答数 0

云产品推荐

上海奇点人才服务相关的云产品 小程序定制 上海微企信息技术相关的云产品 国内短信套餐包 ECS云服务器安全配置相关的云产品 开发者问答 阿里云建站 自然场景识别相关的云产品 万网 小程序开发制作 视频内容分析 视频集锦 代理记账服务 阿里云AIoT